/** mixerNX
 * http://hp.vector.co.jp/authors/VA016117/mixer1.html
 * NX́B
 */

#ifndef mymixerctr_h
#define mymixerctr_h

#include <windows.h>
#include <mmsystem.h>

class TMixerCtr
{
public:
	TMixerCtr()
    {
	    initValue() ;
    }

	~TMixerCtr()
    {
	    release() ;
    }

    /** Mixeȑ
     * hw  MM_MIXM_LINE_CHANGE, MM_MIXM_CONTROL_CHANGE 
     */
	bool init(HWND hw)
    {
	    if ( m_hMixer ) return true ;

    	if ( ::mixerOpen( &m_hMixer, 0, (DWORD)hw, 0, CALLBACK_WINDOW ) != MMSYSERR_NOERROR )
        {
            return false ;
        }
    	//if ( ::mixerGetDevCaps( (UINT)m_hMixer, &m_mxcaps, sizeof(MIXERCAPS))!=MMSYSERR_NOERROR ) return false ;

	    return	true ;
    }

    /** Mixeřn
     */
	void release(void)
    {
	    if ( m_hMixer ) ::mixerClose( m_hMixer ) ;
        initValue() ;
    }

	bool getVolume(int *Val) ; //Val:0(Min) - 100(Max)
	bool setVolume(int Val) ;

	bool addVolume(int dif)
    {
	    int	Val ;
    	if ( getVolume( &Val ) == false ) return false ;

	    Val += dif ;
    	if ( Val > 100 ) Val = 100 ;
        else if( Val < 0 ) Val = 0 ;

	    if ( setVolume( Val ) == false ) return false ;

    	return true ;
    }

	bool getMuteState(bool *Val) ;
	bool setMuteState(bool Val) ;
	bool toggleMute(void)
    {
	    bool bMute ;
    	if ( getMuteState( &bMute ) == false ) return false ;
	    return setMuteState( ! bMute ) ;
    }
private:
    /** ȍ
     */
    void initValue(void)
    {
	    m_hMixer = NULL ;
    	m_dwVolumeControlID = 0xffffffff ;
	    m_dwMuteControlID   = 0xffffffff ;
    }

	bool initMasterVolumeControl(void) ;
	bool initMasterMuteControl(void) ;
	HMIXER		m_hMixer ;
	//MIXERCAPS	m_mxcaps ;
	DWORD		m_dwMinimum ;
	DWORD		m_dwMaximum ;
	DWORD		m_cChannels ;
	DWORD		m_dwVolumeControlID ;
	DWORD		m_dwMuteControlID ;
} ;

#endif /* mymixerctr_h */

